<?php

    namespace Modules\Lpj\Http\Controllers;

    use App\Http\Controllers\Controller;
    use Exception;
    use Illuminate\Http\Request;
    use Maatwebsite\Excel\Facades\Excel;
    use Modules\Lpj\Exports\JenisAsetExport;
    use Modules\Lpj\Http\Requests\JenisAsetRequest;
    use Modules\Lpj\Models\JenisAset;

    class JenisAsetController extends Controller
    {
        public $user;

        public function index()
        {
            return view('lpj::jenis_aset.index');
        }

        public function store(JenisAsetRequest $request)
        {
            $validate = $request->validated();

            if ($validate) {
                try {
                    // Save to database
                    JenisAset::create($validate);
                    return redirect()
                        ->route('basicdata.jenis-aset.index')
                        ->with('success', 'Jenis Aset created successfully');
                } catch (Exception $e) {
                    return redirect()
                        ->route('basicdata.jenis-aset.create')
                        ->with('error', 'Failed to create jenis aset');
                }
            }
        }

        public function create()
        {
            return view('lpj::jenis_aset.create');
        }

        public function edit($id)
        {
            $jenisAset = JenisAset::find($id);
            return view('lpj::jenis_aset.create', compact('jenisAset'));
        }

        public function update(JenisAsetRequest $request, $id)
        {
            $validate = $request->validated();

            if ($validate) {
                try {
                    // Update in database
                    $jenisAset = JenisAset::find($id);
                    $jenisAset->update($validate);
                    return redirect()
                        ->route('basicdata.jenis-aset.index')
                        ->with('success', 'Jenis Aset updated successfully');
                } catch (Exception $e) {
                    return redirect()
                        ->route('basicdata.jenis-aset.edit', $id)
                        ->with('error', 'Failed to update jenis aset');
                }
            }
        }

        public function destroy($id)
        {
            try {
                // Delete from database
                $jenisAset = JenisAset::find($id);
                $jenisAset->delete();

                echo json_encode(['success' => true, 'message' => 'Jenis Aset deleted successfully']);
            } catch (Exception $e) {
                echo json_encode(['success' => false, 'message' => 'Failed to delete jenis aset']);
            }
        }

        public function dataForDatatables(Request $request)
        {
            if (is_null($this->user) || !$this->user->can('jenis_aset.view')) {
                //abort(403, 'Sorry! You are not allowed to view users.');
            }

            // Retrieve data from the database
            $query = JenisAset::query();

            // Apply search filter if provided
            if ($request->has('search') && !empty($request->get('search'))) {
                $search = $request->get('search');
                $query->where(function ($q) use ($search) {
                    $q->where('code', 'LIKE', "%$search%");
                    $q->orWhere('name', 'LIKE', "%$search%");
                });
            }

            // Apply sorting if provided
            if ($request->has('sortOrder') && !empty($request->get('sortOrder'))) {
                $order  = $request->get('sortOrder');
                $column = $request->get('sortField');
                $query->orderBy($column, $order);
            }

            // Get the total count of records
            $totalRecords = $query->count();

            // Apply pagination if provided
            if ($request->has('page') && $request->has('size')) {
                $page   = $request->get('page');
                $size   = $request->get('size');
                $offset = ($page - 1) * $size; // Calculate the offset

                $query->skip($offset)->take($size);
            }

            // Get the filtered count of records
            $filteredRecords = $query->count();

            // Get the data for the current page
            $data = $query->get();

            // Calculate the page count
            $pageCount = ceil($totalRecords / $request->get('size'));

            // Calculate the current page number
            $currentPage = 0 + 1;

            // Return the response data as a JSON object
            return response()->json([
                'draw'            => $request->get('draw'),
                'recordsTotal'    => $totalRecords,
                'recordsFiltered' => $filteredRecords,
                'pageCount'       => $pageCount,
                'page'            => $currentPage,
                'totalCount'      => $totalRecords,
                'data'            => $data,
            ]);
        }

        public function export()
        {
            return Excel::download(new JenisAsetExport, 'jenis_aset.xlsx');
        }
    }
